#ifndef SD_H
#define SD_H

#define SD_BLOCKSIZE		512
#define SD_BLOCKSIZE_NBITS 	9
#define SD_CLK_SLOW_DIV		400000
#define SD_TIMEOUT_READ		20
#define MSK_TOK_ERROR		0x01
#define MSK_TOK_DATAERROR	0xE0
#define SD_TOK_WRITE_STARTBLOCK 0xFE
#define SD_IDLE_WAIT_MAX		100
#define SD_CMD_TIMEOUT			100

//Standard voltage range expected
#define SD_ORC_RESPONSE 0x80ff0001

//the new commands, add as needed
//first is we don' t need any commands that return the type 'R1B'
//the comand is high byte and response count is low byte

//Must or mask all commands with 01000000
#define SD_CMDMASK		0x4000
#define SDRTN_R1		1
#define SDRTN_R3		5

#define SDCMD_0   ( SD_CMDMASK | ( 0 << 8 ) | SDRTN_R1 )
#define SDCMD_55  ( SD_CMDMASK | ( 55 << 8 ) | SDRTN_R1 )
#define SDCMD_A41 ( SD_CMDMASK | ( 41 << 8 ) | SDRTN_R1 )
#define SDCMD_58  ( SD_CMDMASK | ( 58 << 8 ) | SDRTN_R3 )
#define SDCMD_17  ( SD_CMDMASK | ( 17 << 8 ) | SDRTN_R1 )
#define SDCMD_24  ( SD_CMDMASK | ( 24 << 8 ) | SDRTN_R1 )

extern BYTE* secBuf;
extern BYTE response[5];
extern WORD block_count;

/* User functions */
bool sd_initialize( );

bool sd_read_block( DWORD blockaddr, const BYTE* pData );

bool sd_write_block( DWORD blockaddr, const BYTE* pData );

bool sd_send_command( WORD cmd, DWORD arg );

void sd_delay( BYTE number );

#endif
